import Quiz from "@/src/components/lms/Lesson/Quiz.tsx";

## Create a new repository on GitHub

You can store your projects' codes in GitHub repositories. You can use repositories to collaborate with others and track your work. To create a new repository on GitHub, follow these steps:

1. Log in to your GitHub account.
2. In the top-right corner of the page, click on the plus sign (+) and select `New repository` from the drop-down menu.
3. Enter a name for your repository, for example, `mesh-web3-course`.
4. You may add a brief description (optional).
5. Select whether you want the repository to be public or private. Public
   repositories are visible to everyone, while private repositories are
   only visible to you and the people you invite to access them.
6. Click on the `Create repository` button to create your new repository.

After your repository is created, you can start adding files to it,
creating branches, and collaborating with others on your project. You
can also customize the settings and options for your repository to suit
your specific needs.

## Clone the repository on GitHub Desktop

To clone a repository on GitHub Desktop, follow these steps:

1. Click on the `File` menu and select `Clone Repository` from the drop-down menu.
2. In the `Clone a Repository` window, select the repository you have just created.
3. Choose the repository you want to clone (i.e. that one your just created).
4. Click on the `Clone` button to clone the repository.

After the repository is cloned, you can access it from the local destination you specified, and you can use GitHub Desktop to manage and work with the repository. You can also push changes you make to the local repository back to the remote repository on GitHub.

## Prepare Workspace

Let's get started!

1. Open Visual Studio Code
2. From the menu, select `File` > `Add Folder to Workspace`
3. Browse to the folder you have created and `Add` folder into your VS Code workspace
4. From the menu, select `Terminal` > `New Terminal`

Your VS Code is ready. You have your VS Code opened, where the working directory is the folder that you have just created, and the Terminal is opened as well.

## Install starter template

Next, we will install a starter template.

In Mesh SDK, we have a number of [starter templates](https://meshjs.dev/starter-templates) to choose from, you can browse, filter them, choose a project and install it. Installing one of templates is the quickest way to get started.

In this course, we will kick start with the most basic template, _Starter Next.js TypeScript_. From the Terminal, run:

```bash
npx create-mesh-app . -t starter -s next -l ts
```

This command is initialize a new project on Next.js. This starter template consists of a connect wallet button and wallet integration.

Installation should take less than a minute. When it is done, you should see:

```bash
✨✨ Welcome to Web 3.0! ✨✨
```

## Start the development server

To start the development server, run:

```bash
npm run dev
```

This command will start the development server on port 3000. Reading the Terminal it should show:

```bash
ready - started server on 0.0.0.0:3000, url: http://localhost:3000
```

You can access the development server by visiting `http://localhost:3000` in your browser. You should see the starter template, with a connect wallet component in the middle.

Click on the `Connect Wallet` button, you should be able to
see a list of wallets you have installed on your device. Choose a wallet
to connect. If you have any trouble getting your wallet to connect, you
may need to enable dApp access from your wallet interface.

If you have successfully connected your wallet, the wallet component
should show the connected wallet's logo and the amount of ADA you have in your wallet.

## Deploy to Vercel

Vercel is a cloud platform for static sites and Serverless Functions that you can deploy your web application to.

To deploy your web application to Vercel, follow these steps:

1. Push your changes to GitHub, by committing your changes with the GitHub Desktop.
2. Go to [Vercel](https://vercel.com/) and create an account.
3. Click on the `New Project` button.
4. Select the repository you have just created.
5. Click on the `Import Project` button.
6. Click on the `Deploy` button to deploy your web application.

After your web application is deployed, you can access it by clicking on the `Visit` button. Congratulations! You have successfully deployed your first web application powered by the Cardano blockchain.

<Quiz
  question="I can get started on web3 development real quick with Mesh's starter kits."
  choices={[
    { value: "right", label: "Yes" },
    { value: "wrong1", label: "No" },
  ]}
  correctAnswer="right"
  correctNote={
    <>Can't wait to see what you will be building, do share with us!</>
  }
  wrongNote={
    <>
      Use of these{" "}
      <a href="https://meshjs.dev/starter-templates">Mesh starter kits</a> and
      start building.
    </>
  }
/>

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
